# Test Frontend 1

The idea with this test is to allow us to better comprehend the skills of candidates to developer jobs, in various experience levels.

This test should be completed by you on your own, in your own time. Take as much time as you need, but usually this test shouldn't take more than a couple of hours to be done.

## Delivery instructions

Download the instructions and build your project. Once done, put all project files in a .zip file and send it to `apply@nuuvem.recruitee.com`. If you have any problems sending the .zip file via email, upload it somewhere and send us the URL to download it.

## Project description

Design and implement a search engine interface that searches a database of Chuck Norris facts, powered by [ChuckNorris.io](https://api.chucknorris.io) API, and display the search results to the user.

The user must be able to do a full-text search and be presented with the matching jokes. When presenting the matching jokes to the user you should display the maximum amount of information that you can find about each joke, in a friendly manner to the user.

The design and usability should consider both desktop and mobile use cases (i.e. use a responsive design). Also, remember to cater to different pixel-density devices (with high DPI displays).

Bonus points:

- Can you implement a "I'm feeling lucky" feature, similar to Google's? Should it use a different result layout? Why (or why not)?
- Can you highlight the search criteria used on the search results? What are the pros and cons of that feature?
- Any other modern techniques or web APIs that you think would be a good fit for this project?

### Implementation

You may develop this project either completely on the front-end or using a mix of front-end and back-end code. It's up to you.

On the front-end side you may use Javascript or Typescript (besides HTML and CSS, of course). On the back-end side (if any), you may use Javascript, Typescript, Ruby or Python.

You may use any (open source) framework or library that you want. You may also only use the standard language and library, without any additional third-party code. Again, it's up to you. **Use what you think is best for the task**.

> If you are applying for a web design only job, or if your programming skills are not sufficient (yet), feel free to implement the layout with fixed responses, like a mockup only. But treat the rest of the code (HTML and CSS) as production-level code.

You may use any build tools that you feel are necessary.

Your project MUST:

1. Be well documented
1. Use semantic markup
1. Have a consistent style and nomenclature in your code
1. Be mindful of performance
1. Be simple to configure and execute, running on a Unix-compatible environment (Linux or macOS or Windows with WSL)
1. Be well tested, with a good test coverage and using both unit and functional / integration / end-to-end automated tests.
1. Use only free / open-source languages and libraries

## Review

Your project will be evaluated by the following criteria:

1. Does the project fulfill the basic requirements?
1. Did you document how to configure, build or run the project?
1. Did you follow closely the project specification?
1. Quality of the user experience, in terms of usability, accessibility and overall visual presentation;
1. Quality of the code itself, how it's strutured and how it complies with good, modern practices;
1. Quality and coverage of unit / funcional / automated tests;
1. Familiarity with the standard libraries of the languages used and other packages;

## Reference

This test was inspired by this other test: <https://github.com/GuiaBolso/seja-um-guia-front>.
